package de.gematik.ti.vauchannel.protocol.helpers;

import org.apache.commons.codec.DecoderException;
import org.apache.commons.codec.binary.Hex;
import org.junit.Assert;
import org.junit.Test;

import java.io.FileInputStream;
import java.io.FileNotFoundException;

import org.apache.commons.io.IOUtils;

import static org.junit.Assert.*;

public class AESGCMTest {

    @Test
    public void generateIV() {
        byte[] iv = AESGCM.generateIV(1L);
        Assert.assertEquals(iv[4], 0);
        Assert.assertEquals(iv[11], 1);
    }

    @Test
    public void decryptMTOMRequest() throws Exception {
        byte[] symkey = Hex.decodeHex("0D6770DCAA6197F233D19028910329FEA837BC2063BA9AE4858AE1047BF67699");
        byte[] request = IOUtils.toByteArray(new FileInputStream("src/test/resources/request.bin"));
        EncData d = new EncData(request);
        VAUProtocolCryptoImpl crypto = new VAUProtocolCryptoImpl();
        Data decryptedData = new Data(d.keyID, crypto.decrypt_AESGCM(d.enc, symkey, -1));
        String bodyString = new String(decryptedData.getDecryptedData().body, "UTF-8");
        System.out.println(bodyString);
    }


}